// Copyright (C) 2005 Code Synthesis Tools CC
//
// This program was generated by XML Schema Definition Compiler (XSD)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// In addition, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef XXXX_ONLINE_INPUT_HXX
#define XXXX_ONLINE_INPUT_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

// Forward declarations.
//
namespace xxxx
{
  class Entity;
}


#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#include <memory> // std::auto_ptr

#include <xsd/cxx/xml/dom/elements.hxx>

#include <xsd/cxx/tree/types.hxx>
#include <xsd/cxx/tree/traits.hxx>
#include <xsd/cxx/tree/functors.hxx>
#include <xsd/cxx/tree/exceptions.hxx>

namespace xml_schema
{
  // anyType
  //
  typedef ::xsd::cxx::tree::type type;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef integer non_positive_integer;
  typedef integer non_negative_integer;
  typedef integer positive_integer;
  typedef integer negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef long double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string_template< char > string;
  typedef ::xsd::cxx::tree::normalized_string_template< char > normalized_string;
  typedef ::xsd::cxx::tree::token_template< char > token;
  typedef ::xsd::cxx::tree::name_template< char > name;
  typedef ::xsd::cxx::tree::nmtoken_template< char > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens_template< char > nmtokens;
  typedef ::xsd::cxx::tree::ncname_template< char > ncname;
  typedef ::xsd::cxx::tree::language_template< char > language;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname_template< char > qname;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id_template< char > id;
  typedef ::xsd::cxx::tree::idref_template< type, char > idref;
  typedef ::xsd::cxx::tree::idrefs_template< type, char > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri_template< char > uri;

  // Binary.
  //
  typedef ::xsd::cxx::tree::base64_binary_template< char > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary_template< char > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::date_template< char > date;
  typedef ::xsd::cxx::tree::date_time_template< char > date_time;
  typedef ::xsd::cxx::tree::duration_template< char > duration;
  typedef ::xsd::cxx::tree::day_template< char > day;
  typedef ::xsd::cxx::tree::month_template< char > month;
  typedef ::xsd::cxx::tree::month_day_template< char > month_day;
  typedef ::xsd::cxx::tree::year_template< char > year;
  typedef ::xsd::cxx::tree::year_month_template< char > year_month;
  typedef ::xsd::cxx::tree::time_template< char > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity_template< char > entity;
  typedef ::xsd::cxx::tree::entities_template< char > entities;

  // Exceptions. See xsd/cxx/tree/exceptions.hxx for details.
  //
  typedef ::xsd::cxx::tree::exception exception;
  typedef ::xsd::cxx::tree::invalid_instance invalid_instance;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::unexpected_attribute< char > unexpected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::serialization serialization;
  typedef ::xsd::cxx::tree::mapping< char > mapping;
  typedef ::xsd::cxx::tree::xsi_already_in_use xsi_already_in_use;
}

namespace xxxx
{
  class Entity : public ::xsd::cxx::tree::type
  {
    struct _xsd_Entity
    {
      typedef ::xsd::cxx::tree::type base_;
      typedef ::xsd::cxx::tree::type member_;
      typedef ::xsd::cxx::tree::traits< base_ > traits_;
    };

    // EntityID
    // 
    public:
    struct _xsd_EntityID
    {
      typedef ::xml_schema::string type_;
      typedef ::xsd::cxx::tree::traits< type_ > traits_;
    };

    public:
    struct EntityID
    {
      typedef _xsd_EntityID::type_ type;
    };

    ::xsd::cxx::tree::one_functor< _xsd_EntityID::type_ > EntityID;

    // firstName
    // 
    public:
    struct _xsd_firstName
    {
      typedef ::xml_schema::string type_;
      typedef ::xsd::cxx::tree::traits< type_ > traits_;
    };

    public:
    struct firstName
    {
      typedef _xsd_firstName::type_ type;
    };

    ::xsd::cxx::tree::one_functor< _xsd_firstName::type_ > firstName;

    // middleName
    // 
    public:
    struct _xsd_middleName
    {
      typedef ::xml_schema::string type_;
      typedef ::xsd::cxx::tree::traits< type_ > traits_;
    };

    public:
    struct middleName
    {
      typedef _xsd_middleName::type_ type;
    };

    ::xsd::cxx::tree::one_functor< _xsd_middleName::type_ > middleName;

    // lastName
    // 
    public:
    struct _xsd_lastName
    {
      typedef ::xml_schema::string type_;
      typedef ::xsd::cxx::tree::traits< type_ > traits_;
    };

    public:
    struct lastName
    {
      typedef _xsd_lastName::type_ type;
    };

    ::xsd::cxx::tree::one_functor< _xsd_lastName::type_ > lastName;

    // relationshipType
    // 
    public:
    struct _xsd_relationshipType
    {
      typedef int type_;
      typedef ::xsd::cxx::tree::traits< type_ > traits_;
    };

    public:
    struct relationshipType
    {
      typedef _xsd_relationshipType::type_ type;
    };

    ::xsd::cxx::tree::one_functor< _xsd_relationshipType::type_ > relationshipType;

    // entityType
    // 
    public:
    struct _xsd_entityType
    {
      typedef int type_;
      typedef ::xsd::cxx::tree::traits< type_ > traits_;
    };

    public:
    struct entityType
    {
      typedef _xsd_entityType::type_ type;
    };

    ::xsd::cxx::tree::one_functor< _xsd_entityType::type_ > entityType;

    public:
    Entity (_xsd_EntityID::type_ const& ,
    _xsd_firstName::type_ const& ,
    _xsd_middleName::type_ const& ,
    _xsd_lastName::type_ const& ,
    _xsd_relationshipType::type_ const& ,
    _xsd_entityType::type_ const& );

    explicit
    Entity (::xsd::cxx::xml::dom::element< char > const&);

    Entity (Entity const&);
  };
}

#include <iosfwd>

namespace xxxx
{
  // Read from a URI or a local file.
  //

  ::std::auto_ptr< class ::xxxx::Entity >
  watchlistinput (::std::basic_string< char > const&);

  ::std::auto_ptr< class ::xxxx::Entity >
  watchlistinput (::std::basic_string< char > const&, ::xercesc::DOMErrorHandler&);


  // Read from std::istream.
  //

  ::std::auto_ptr< class ::xxxx::Entity >
  watchlistinput (std::istream&);

  ::std::auto_ptr< class ::xxxx::Entity >
  watchlistinput (std::istream&, ::xercesc::DOMErrorHandler&);


  ::std::auto_ptr< class ::xxxx::Entity >
  watchlistinput (std::istream&, ::std::basic_string< char > const& id);

  ::std::auto_ptr< class ::xxxx::Entity >
  watchlistinput (std::istream&, ::std::basic_string< char > const& id, ::xercesc::DOMErrorHandler&);


  // Read from InputSource.
  //

  ::std::auto_ptr< class ::xxxx::Entity >
  watchlistinput (::xercesc::DOMInputSource const&);

  ::std::auto_ptr< class ::xxxx::Entity >
  watchlistinput (::xercesc::DOMInputSource const&, ::xercesc::DOMErrorHandler&);


  // Read from DOM.
  //

  ::std::auto_ptr< class ::xxxx::Entity >
  watchlistinput (::xercesc::DOMDocument const&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // XXXX_ONLINE_INPUT_HXX
